Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.valves
Class AccessLogValve

    java.lang.Object
      org.apache.catalina.valves.ValveBase
          org.apache.catalina.valves.AccessLogValve

All Implemented Interfaces:
  Contained, Lifecycle, javax.management.MBeanRegistration, Valve

public final class AccessLogValve
extends ValveBase
implements Lifecycle

Implementation of the Valve interface that generates a web server access log with the detailed line contents matching a configurable pattern. The syntax of the available patterns is similar to that supported by the Apache `mod_log_config` module. As an additional feature, automatic rollover of log files when the date changes is also supported.

Patterns for the logged message may include constant text or any of the following replacement strings, for which the corresponding information from the specified Response is substituted:

- %a - Remote IP address
- %A - Local IP address
- %b - Bytes sent, excluding HTTP headers, or '-' if no bytes were sent
- %B - Bytes sent, excluding HTTP headers
- %h - Remote host name
- %H - Request protocol
- %l - Remote logical username from identd (always returns '-')
- %m - Request method
- %p - Local port
- %q - Query string (prepended with a '?' if it exists, otherwise an empty string
- %r - First line of the request
- %s - HTTP status code of the response
- %S - User session ID
- %t - Date and time, in Common Log Format format
- %u - Remote user that was authenticated
- %U - Requested URL path
- %v - Local server name
- %D - Time taken to process the request, in millis
- %T - Time taken to process the request, in seconds

In addition, the caller can specify one of the following aliases for commonly utilized patterns:

- common - `%h %l %u %t "%r" %s %b`
- combined - `%h %l %u %t "%r" %s %b "%{Referer}i" "%{User-Agent}i"`

There is also support to write information from the cookie, incoming header, the Session or something else in the ServletRequest.
It is modeled after the apache syntax:

- `%{xxx}i` for incoming headers
- `%{xxx}c` for a specific cookie
- `%{xxx}r` xxx is an attribute in the ServletRequest
- `%{xxx}s` xxx is an attribute in the HttpSession

Conditional logging is also supported. This can be done with the `condition` property. If the value returned from ServletRequest.getAttribute(condition) yields a non-null value. The logging will be skipped.

Version:
  $Revision: 1.10 $ $Date: 2004/02/27 14:58:52 $
Author:
  Craig R. McClanahan, Jason Brittain

Field Summary
`protected static java.lang.String` | `info` The descriptive information about this implementation.
`protected LifecycleSupport` | `lifecycle` The lifecycle event support for this component.
`protected static java.lang.String[]` | `months` The set of month abbreviations for log messages.

Fields inherited from class org.apache.catalina.valves.ValveBase
`container, controller, debug, domain, mserver, oname`

Fields inherited from interface org.apache.catalina.Lifecycle
`AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, START_EVENT, STOP_EVENT`

Constructor Summary
`AccessLogValve()` Construct a new instance of this class with default property values.

Method Summary
`void` | `addLifecycleListener(LifecycleListener listener)` Add a lifecycle event listener to this component.
`LifecycleListener[]` | `findLifecycleListeners()` Get the lifecycle listeners associated with this lifecycle.
`java.lang.String` | `getCondition()` Return whether the attribute name to look for when performing conditional loggging.
`java.lang.String` | `getDirectory()` Return the directory in which we create log files.
`java.lang.String` | `getFileDateFormat()` Return the date format date based log rotation.
`java.lang.String` | `getInfo()` Return descriptive information about this implementation.
`java.lang.String` | `getPattern()` Return the format pattern.
`java.lang.String` | `getPrefix()` Return the log file prefix.
`java.lang.String` | `getSuffix()` Return the log file suffix.
`void` | `invoke(Request request, Response response, ValveContext context)` Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.
`boolean` | `isResolveHosts()` Get the value of the resolve hosts flag.
`boolean` | `isRotatable()` Should we rotate the logs
`void` | `log(java.lang.String message, java.util.Date date)` Log the specified message to the log file, switching files if the date has changed since the previous log call.
`void` | `removeLifecycleListener(LifecycleListener listener)` Remove a lifecycle event listener from this component.
`void` | `setCondition(java.lang.String condition)` Set the ServletRequest.attribute to look for to perform conditional logging.
`void` | `setDirectory(java.lang.String directory)` Set the directory in which we create log files.
`void` | `setFileDateFormat(java.lang.String fileDateFormat)` Set the date format date based log rotation.
`void` | `setPattern(java.lang.String pattern)` Set the format pattern, first translating any recognized alias.
`void` | `setPrefix(java.lang.String prefix)` Set the log file prefix.
`void` | `setResolveHosts(boolean resolveHosts)` Set the resolve hosts flag.
`void` | `setRotatable(boolean rotatable)` Set the value is we should we rotate the logs
`void` | `setSuffix(java.lang.String suffix)` Set the log file suffix.
`void` | `start()` Prepare for the beginning of active use of the public methods of this component.
`void` | `stop()` Gracefully terminate the active use of the public methods of this component.

Methods inherited from class org.apache.catalina.valves.ValveBase
`createObjectName, getContainer, getContainerName, getController, getDebug, getDomain, getObjectName, getParentName, postDeregister, postRegister, preDeregister, preRegister, setContainer, setController, setDebug, setObjectName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### info

    protected static final java.lang.String info

  The descriptive information about this implementation.

  See Also:
    Constant Field Values

### lifecycle

    protected LifecycleSupport lifecycle

  The lifecycle event support for this component.

### months

    protected static final java.lang.String[] months

  The set of month abbreviations for log messages.

Constructor Detail

### AccessLogValve

    public AccessLogValve()

  Construct a new instance of this class with default property values.

Method Detail

### getDirectory

    public java.lang.String getDirectory()

  Return the directory in which we create log files.

### setDirectory

    public void setDirectory(java.lang.String directory)

  Set the directory in which we create log files.

  Parameters:
    `directory` - The new log file directory

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this implementation.

  Specified by:
    `getInfo` in interface `Valve`
  Overrides:
    `getInfo` in class `ValveBase`

### getPattern

    public java.lang.String getPattern()

  Return the format pattern.

### setPattern

    public void setPattern(java.lang.String pattern)

  Set the format pattern, first translating any recognized alias.

  Parameters:
    `pattern` - The new pattern

### getPrefix

    public java.lang.String getPrefix()

  Return the log file prefix.

### setPrefix

    public void setPrefix(java.lang.String prefix)

  Set the log file prefix.

  Parameters:
    `prefix` - The new log file prefix

### isRotatable

    public boolean isRotatable()

  Should we rotate the logs

### setRotatable

    public void setRotatable(boolean rotatable)

  Set the value is we should we rotate the logs

  Parameters:
    `rotatable` - true is we should rotate.

### getSuffix

    public java.lang.String getSuffix()

  Return the log file suffix.

### setSuffix

    public void setSuffix(java.lang.String suffix)

  Set the log file suffix.

  Parameters:
    `suffix` - The new log file suffix

### setResolveHosts

    public void setResolveHosts(boolean resolveHosts)

  Set the resolve hosts flag.

  Parameters:
    `resolveHosts` - The new resolve hosts value

### isResolveHosts

    public boolean isResolveHosts()

  Get the value of the resolve hosts flag.

### getCondition

    public java.lang.String getCondition()

  Return whether the attribute name to look for when performing conditional loggging. If null, every request is logged.

### setCondition

    public void setCondition(java.lang.String condition)

  Set the ServletRequest.attribute to look for to perform conditional logging. Set to null to log everything.

  Parameters:
    `condition` - Set to null to log everything

### getFileDateFormat

    public java.lang.String getFileDateFormat()

  Return the date format date based log rotation.

### setFileDateFormat

    public void setFileDateFormat(java.lang.String fileDateFormat)

  Set the date format date based log rotation.

### invoke

    public void invoke(Request request,
                       Response response,
                       ValveContext context)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.

  Specified by:
    `invoke` in interface `Valve`
  Specified by:
    `invoke` in class `ValveBase`
  Parameters:
    `request` - Request being processed
    `response` - Response being processed
    `context` - The valve context used to invoke the next valve in the current processing pipeline
  Throws:
    `java.io.IOException` - if an input/output error has occurred
    `javax.servlet.ServletException` - if a servlet error has occurred

### log

    public void log(java.lang.String message,
                    java.util.Date date)

  Log the specified message to the log file, switching files if the date has changed since the previous log call.

  Parameters:
    `message` - Message to be logged
    `date` - the current Date object (so this method doesn't need to create a new one)

### addLifecycleListener

    public void addLifecycleListener(LifecycleListener listener)

  Add a lifecycle event listener to this component.

  Specified by:
    `addLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to add

### findLifecycleListeners

    public LifecycleListener[] findLifecycleListeners()

  Get the lifecycle listeners associated with this lifecycle. If this Lifecycle has no listeners registered, a zero-length array is returned.

  Specified by:
    `findLifecycleListeners` in interface `Lifecycle`

### removeLifecycleListener

    public void removeLifecycleListener(LifecycleListener listener)

  Remove a lifecycle event listener from this component.

  Specified by:
    `removeLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to add

### start

    public void start()
               throws LifecycleException

  Prepare for the beginning of active use of the public methods of this component. This method should be called after `configure()`, and before any of the public methods of the component are utilized.

  Specified by:
    `start` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that prevents this component from being used

### stop

    public void stop()
              throws LifecycleException

  Gracefully terminate the active use of the public methods of this component. This method should be the last one called on a given instance of this component.

  Specified by:
    `stop` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that needs to be reported

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.